library ksalert_view;

import 'package:flutter/material.dart';

/// A Calculator.

class ksalert_view<T> extends PopupRoute<T> {

  @override
  Color get barrierColor => null;

  @override
  bool get barrierDismissible => false;

  @override
  String get barrierLabel => null;

  @override
  Duration get transitionDuration => Duration(seconds: 0);

  final Widget title;
  final Widget content;
  final List<Widget> actions;
  final Widget actionCancell;
  final Widget actionConfirm;

  /// backgroudView Color
  final Color backgroudViewColor;
  /// child'alignment, default value: [Alignment.center]
  final Alignment alignment;
  /// child
  final Widget child;
  /// backgroudView action

  ksalert_view({
    this.title,
    this.content,
    this.actions,
    this.actionCancell,
    this.actionConfirm,
    this.backgroudViewColor,
    this.alignment = Alignment.center,
    this.child,
  });

  @override
  Widget buildPage(BuildContext context, Animation<double> animation, Animation<double> secondaryAnimation) {
    final screenSize = MediaQuery.of(context).size;
    double spacingVer = 8;
    double spacingHor = 15;
    bool isDark = Theme.of(context).brightness == Brightness.dark;

    return Material(
      color: Colors.transparent,
      child: GestureDetector(
        child: Stack(
          children: [
            Container(
              width: screenSize.width,
              height: screenSize.height,
              color: backgroudViewColor ?? Colors.black.withOpacity(0.3),
            ),
            SafeArea(
              child: Align(
                alignment: alignment,
                child: Container(
                  width: screenSize.width - 60,
                  decoration: BoxDecoration(
                    color: isDark ? Colors.black : Colors.white,
                    borderRadius: BorderRadius.circular((10.0)), // 圆角度
                  ),
                  child: Column(
                    mainAxisSize: MainAxisSize.min,
                    children: <Widget>[
                      if (title != null) Padding(
                        padding: EdgeInsets.only(top: spacingVer, left: spacingHor, bottom: spacingVer, right: spacingHor),
                        child: title,
                      ),
                      if (title != null) Padding(
                        padding: EdgeInsets.only(left: spacingHor, bottom: spacingVer, right: spacingHor),
                        child: content,
                      ),
                      Container(
                        height: 0.5,
                        color: Colors.grey[400],
                      ),
                      Row(
                        mainAxisSize: MainAxisSize.min,
                        children: actions != null ? actions.map((e) => Expanded(child: e,),).toList()
                            :
                        [
                          if (actionCancell != null) Expanded(child: actionCancell,),
                          if (actionCancell != null) Container(height: 55, child: VerticalDivider(color: Colors.grey[400])),
                          if (actionConfirm != null) Expanded(child: actionConfirm,),
                        ],
                      ),

                    ],
                  ),
                ),
              ),
            ),
          ],
        ),
        onTap: () {
          if (actionCancell == null && actionConfirm == null && actions == null) Navigator.of(context).pop();

        },
      ),
    );
  }
}